#!/usr/bin/env node
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.muck = exports.muckFile = exports.settings = undefined;

var _keys2 = require('babel-runtime/core-js/object/keys');

var _keys3 = _interopRequireDefault(_keys2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var confirm = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(message, _ref2) {
        var _ref2$confirm = _ref2.confirm,
            confirm = _ref2$confirm === undefined ? false : _ref2$confirm;
        var answer;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        if (!confirm) {
                            _context.next = 5;
                            break;
                        }

                        _context.next = 3;
                        return _inquirer2.default.prompt([{ message: message, type: 'confirm', name: 'confirm' }]);

                    case 3:
                        answer = _context.sent;
                        return _context.abrupt('return', answer.confirm);

                    case 5:
                        return _context.abrupt('return', true);

                    case 6:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function confirm(_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();

var _set = function () {
    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(json, _ref4, filename, options) {
        var _ref5 = (0, _slicedToArray3.default)(_ref4, 2),
            key = _ref5[0],
            value = _ref5[1];

        var current, hasKey;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        current = (0, _get3.default)(json, key);

                        if (!(current === value)) {
                            _context2.next = 3;
                            break;
                        }

                        return _context2.abrupt('return', false);

                    case 3:
                        hasKey = (0, _has2.default)(json, key);

                        if (!hasKey) {
                            _context2.next = 9;
                            break;
                        }

                        if (!options.skipIfExists) {
                            _context2.next = 7;
                            break;
                        }

                        return _context2.abrupt('return', false);

                    case 7:
                        _context2.next = 11;
                        break;

                    case 9:
                        if (!options.onlyIfExists) {
                            _context2.next = 11;
                            break;
                        }

                        return _context2.abrupt('return', false);

                    case 11:
                        _context2.next = 13;
                        return confirm('Are you sure you want to change ' + key + ' in \'' + this.name + '/' + filename + '?\' ' + (hasKey ? '[' + (0, _stringify2.default)(current, null, 2) + ']' : ''), options);

                    case 13:
                        if (!_context2.sent) {
                            _context2.next = 16;
                            break;
                        }

                        (0, _set3.default)(json, key, value);
                        return _context2.abrupt('return', true);

                    case 16:
                        return _context2.abrupt('return', false);

                    case 17:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, this);
    }));

    return function _set(_x3, _x4, _x5, _x6) {
        return _ref3.apply(this, arguments);
    };
}();

var _move = function () {
    var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(json, keys, filename, opts) {
        var _keys, from, to, f, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, key;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        _keys = (0, _slicedToArray3.default)(keys, 2), from = _keys[0], to = _keys[1];

                        if (!from || !to) {
                            settings.warn('move requires an argument', from, to);
                        }

                        if (!(0, _has2.default)(json, from)) {
                            _context3.next = 33;
                            break;
                        }

                        _context3.next = 5;
                        return confirm('Are you sure you want to move \'' + from + '\' to \'' + to + '\' in \'' + filename + '?\'', opts);

                    case 5:
                        if (_context3.sent) {
                            _context3.next = 7;
                            break;
                        }

                        return _context3.abrupt('return', false);

                    case 7:
                        f = (0, _get3.default)(json, from);

                        (0, _unset2.default)(json, from);
                        //Merge objects if there is a destination

                        if (!((typeof f === 'undefined' ? 'undefined' : (0, _typeof3.default)(f)) === 'object' && (0, _get3.default)(json, to))) {
                            _context3.next = 31;
                            break;
                        }

                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        _context3.prev = 13;

                        for (_iterator = (0, _getIterator3.default)((0, _keys3.default)(f)); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                            key = _step.value;

                            (0, _set3.default)(json, to + '.' + key, f[key]);
                        }
                        _context3.next = 21;
                        break;

                    case 17:
                        _context3.prev = 17;
                        _context3.t0 = _context3['catch'](13);
                        _didIteratorError = true;
                        _iteratorError = _context3.t0;

                    case 21:
                        _context3.prev = 21;
                        _context3.prev = 22;

                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }

                    case 24:
                        _context3.prev = 24;

                        if (!_didIteratorError) {
                            _context3.next = 27;
                            break;
                        }

                        throw _iteratorError;

                    case 27:
                        return _context3.finish(24);

                    case 28:
                        return _context3.finish(21);

                    case 29:
                        _context3.next = 32;
                        break;

                    case 31:
                        (0, _set3.default)(json, to, f);

                    case 32:
                        return _context3.abrupt('return', true);

                    case 33:
                        return _context3.abrupt('return', false);

                    case 34:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, this, [[13, 17, 21, 29], [22,, 24, 28]]);
    }));

    return function _move(_x7, _x8, _x9, _x10) {
        return _ref6.apply(this, arguments);
    };
}();

// noinspection JSUnusedLocalSymbols
var _delete = function () {
    var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(json, keys, filename, opts) {
        var ret, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, key;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        ret = false;
                        _iteratorNormalCompletion2 = true;
                        _didIteratorError2 = false;
                        _iteratorError2 = undefined;
                        _context4.prev = 4;
                        _iterator2 = (0, _getIterator3.default)(keys);

                    case 6:
                        if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                            _context4.next = 18;
                            break;
                        }

                        key = _step2.value;

                        if (!(0, _has2.default)(json, key)) {
                            _context4.next = 13;
                            break;
                        }

                        _context4.next = 11;
                        return confirm('Are you sure you want to delete \'' + key + '\'', opts);

                    case 11:
                        if (_context4.sent) {
                            _context4.next = 13;
                            break;
                        }

                        return _context4.abrupt('continue', 15);

                    case 13:
                        (0, _unset2.default)(json, key);
                        ret |= true;

                    case 15:
                        _iteratorNormalCompletion2 = true;
                        _context4.next = 6;
                        break;

                    case 18:
                        _context4.next = 24;
                        break;

                    case 20:
                        _context4.prev = 20;
                        _context4.t0 = _context4['catch'](4);
                        _didIteratorError2 = true;
                        _iteratorError2 = _context4.t0;

                    case 24:
                        _context4.prev = 24;
                        _context4.prev = 25;

                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                            _iterator2.return();
                        }

                    case 27:
                        _context4.prev = 27;

                        if (!_didIteratorError2) {
                            _context4.next = 30;
                            break;
                        }

                        throw _iteratorError2;

                    case 30:
                        return _context4.finish(27);

                    case 31:
                        return _context4.finish(24);

                    case 32:
                        return _context4.abrupt('return', ret);

                    case 33:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, this, [[4, 20, 24, 32], [25,, 27, 31]]);
    }));

    return function _delete(_x12, _x13, _x14, _x15) {
        return _ref7.apply(this, arguments);
    };
}();

var _prompt = function () {
    var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(json, args, filename, options) {
        var _args5, key, _args5$, vmessage, self, _default, message, hasKey, answer;

        return _regenerator2.default.wrap(function _callee5$(_context5) {
            while (1) {
                switch (_context5.prev = _context5.next) {
                    case 0:
                        _args5 = (0, _slicedToArray3.default)(args, 2), key = _args5[0], _args5$ = _args5[1], vmessage = _args5$ === undefined ? 'Do you want to change the property' : _args5$, self = this, _default = (0, _get3.default)(json, key), message = vmessage + ' \'' + key + '\' in \'' + this.name + '/' + filename + '\'?';

                        if (!(options.skipIfExists && _default != null)) {
                            _context5.next = 3;
                            break;
                        }

                        return _context5.abrupt('return', false);

                    case 3:
                        hasKey = (0, _has2.default)(json, key);

                        if (!hasKey) {
                            _context5.next = 9;
                            break;
                        }

                        if (!options.skipIfExists) {
                            _context5.next = 7;
                            break;
                        }

                        return _context5.abrupt('return', false);

                    case 7:
                        _context5.next = 11;
                        break;

                    case 9:
                        if (!options.onlyIfExists) {
                            _context5.next = 11;
                            break;
                        }

                        return _context5.abrupt('return', false);

                    case 11:
                        _context5.next = 13;
                        return confirm(message, { confirm: true });

                    case 13:
                        if (!_context5.sent) {
                            _context5.next = 28;
                            break;
                        }

                        _context5.next = 16;
                        return _inquirer2.default.prompt([{
                            type: 'input',
                            name: 'value',
                            message: (0, _has2.default)(json, key) ? 'OK what would like to change it to?' : vmessage
                        }]);

                    case 16:
                        answer = _context5.sent;

                        if (!(answer.value === _default)) {
                            _context5.next = 19;
                            break;
                        }

                        return _context5.abrupt('return', false);

                    case 19:
                        _context5.prev = 19;

                        (0, _set3.default)(json, key, parse(answer.value));
                        return _context5.abrupt('return', true);

                    case 24:
                        _context5.prev = 24;
                        _context5.t0 = _context5['catch'](19);

                        settings.warn('Could not parse the value try again', _context5.t0);

                    case 27:
                        return _context5.abrupt('return', _prompt.call(self, json, args, filename, options));

                    case 28:
                    case 'end':
                        return _context5.stop();
                }
            }
        }, _callee5, this, [[19, 24]]);
    }));

    return function _prompt(_x16, _x17, _x18, _x19) {
        return _ref8.apply(this, arguments);
    };
}();

var muckFile = exports.muckFile = function () {
    var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(pkg, file, opts) {
        var saveMuck, fullname, json, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, cmd, backup, newfile;

        return _regenerator2.default.wrap(function _callee6$(_context6) {
            while (1) {
                switch (_context6.prev = _context6.next) {
                    case 0:
                        saveMuck = false;
                        fullname = _path2.default.resolve(pkg.location, file);
                        json = void 0;
                        _context6.prev = 3;
                        _context6.next = 6;
                        return read(fullname);

                    case 6:
                        json = _context6.sent;
                        _context6.next = 17;
                        break;

                    case 9:
                        _context6.prev = 9;
                        _context6.t0 = _context6['catch'](3);

                        if (!(opts.createIfNotExists && !_fs2.default.existsSync(fullname))) {
                            _context6.next = 15;
                            break;
                        }

                        json = {};
                        _context6.next = 17;
                        break;

                    case 15:
                        settings.warn('Error reading ' + fullname, _context6.t0);
                        return _context6.abrupt('return', false);

                    case 17:
                        _iteratorNormalCompletion3 = true;
                        _didIteratorError3 = false;
                        _iteratorError3 = undefined;
                        _context6.prev = 20;
                        _iterator3 = (0, _getIterator3.default)(opts.commands);

                    case 22:
                        if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
                            _context6.next = 31;
                            break;
                        }

                        cmd = _step3.value;
                        _context6.next = 26;
                        return cmd[0].call(pkg, json, cmd[1], file, opts);

                    case 26:
                        if (!_context6.sent) {
                            _context6.next = 28;
                            break;
                        }

                        saveMuck = true;

                    case 28:
                        _iteratorNormalCompletion3 = true;
                        _context6.next = 22;
                        break;

                    case 31:
                        _context6.next = 37;
                        break;

                    case 33:
                        _context6.prev = 33;
                        _context6.t1 = _context6['catch'](20);
                        _didIteratorError3 = true;
                        _iteratorError3 = _context6.t1;

                    case 37:
                        _context6.prev = 37;
                        _context6.prev = 38;

                        if (!_iteratorNormalCompletion3 && _iterator3.return) {
                            _iterator3.return();
                        }

                    case 40:
                        _context6.prev = 40;

                        if (!_didIteratorError3) {
                            _context6.next = 43;
                            break;
                        }

                        throw _iteratorError3;

                    case 43:
                        return _context6.finish(40);

                    case 44:
                        return _context6.finish(37);

                    case 45:
                        if (!(saveMuck && json)) {
                            _context6.next = 72;
                            break;
                        }

                        backup = fullname + opts.extension;
                        newfile = fullname;

                        if (!opts.preview) {
                            _context6.next = 54;
                            break;
                        }

                        settings.log((0, _stringify2.default)(json, null, 2));
                        _context6.next = 52;
                        return confirm('Does above look correct for ' + fullname, { confirm: true });

                    case 52:
                        if (_context6.sent) {
                            _context6.next = 54;
                            break;
                        }

                        return _context6.abrupt('return', false);

                    case 54:
                        if (opts.noExtension) {
                            _context6.next = 63;
                            break;
                        }

                        _context6.t2 = _fs2.default.existsSync(backup);

                        if (!_context6.t2) {
                            _context6.next = 60;
                            break;
                        }

                        _context6.next = 59;
                        return confirm('a file named ' + newfile + ' already, do want to overwrite?', opts);

                    case 59:
                        _context6.t2 = !_context6.sent;

                    case 60:
                        if (!_context6.t2) {
                            _context6.next = 62;
                            break;
                        }

                        return _context6.abrupt('return', false);

                    case 62:
                        //rename the current file.
                        _fs2.default.renameSync(newfile, backup);

                    case 63:
                        _context6.prev = 63;
                        _context6.next = 66;
                        return write(newfile, json);

                    case 66:
                        _context6.next = 72;
                        break;

                    case 68:
                        _context6.prev = 68;
                        _context6.t3 = _context6['catch'](63);

                        if (backup != newfile && _fs2.default.existsSync(backup)) {
                            try {
                                _fs2.default.renameSync(backup, newfile);
                            } catch (ee) {
                                settings.warn('Error renaming ' + backup + ' back to ' + newfile, _context6.t3);
                            }
                        }
                        settings.warn('Error writing ' + newfile, _context6.t3);

                    case 72:
                        return _context6.abrupt('return', true);

                    case 73:
                    case 'end':
                        return _context6.stop();
                }
            }
        }, _callee6, this, [[3, 9], [20, 33, 37, 45], [38,, 40, 44], [63, 68]]);
    }));

    return function muckFile(_x20, _x21, _x22) {
        return _ref9.apply(this, arguments);
    };
}();

var muck = exports.muck = function () {
    var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(opts) {
        var options, filteredPackages, _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, pkg, _iteratorNormalCompletion5, _didIteratorError5, _iteratorError5, _iterator5, _step5, file, _iteratorNormalCompletion6, _didIteratorError6, _iteratorError6, _iterator6, _step6, _file;

        return _regenerator2.default.wrap(function _callee7$(_context7) {
            while (1) {
                switch (_context7.prev = _context7.next) {
                    case 0:
                        if (opts.noLerna) {
                            _context7.next = 60;
                            break;
                        }

                        options = {};

                        if (opts.cwd) {
                            options.cwd = opts.cwd;
                        }
                        if (opts.scope) {
                            options.scope = opts.scope;
                        }
                        _context7.next = 6;
                        return (0, _mrbuilderUtils.lernaFilteredPackages)(opts);

                    case 6:
                        filteredPackages = _context7.sent;


                        opts.filteredPackages = filteredPackages;
                        _iteratorNormalCompletion4 = true;
                        _didIteratorError4 = false;
                        _iteratorError4 = undefined;
                        _context7.prev = 11;
                        _iterator4 = (0, _getIterator3.default)(filteredPackages);

                    case 13:
                        if (_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done) {
                            _context7.next = 44;
                            break;
                        }

                        pkg = _step4.value;
                        _iteratorNormalCompletion5 = true;
                        _didIteratorError5 = false;
                        _iteratorError5 = undefined;
                        _context7.prev = 18;
                        _iterator5 = (0, _getIterator3.default)(opts.files);

                    case 20:
                        if (_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done) {
                            _context7.next = 27;
                            break;
                        }

                        file = _step5.value;
                        _context7.next = 24;
                        return muckFile(pkg, file, opts);

                    case 24:
                        _iteratorNormalCompletion5 = true;
                        _context7.next = 20;
                        break;

                    case 27:
                        _context7.next = 33;
                        break;

                    case 29:
                        _context7.prev = 29;
                        _context7.t0 = _context7['catch'](18);
                        _didIteratorError5 = true;
                        _iteratorError5 = _context7.t0;

                    case 33:
                        _context7.prev = 33;
                        _context7.prev = 34;

                        if (!_iteratorNormalCompletion5 && _iterator5.return) {
                            _iterator5.return();
                        }

                    case 36:
                        _context7.prev = 36;

                        if (!_didIteratorError5) {
                            _context7.next = 39;
                            break;
                        }

                        throw _iteratorError5;

                    case 39:
                        return _context7.finish(36);

                    case 40:
                        return _context7.finish(33);

                    case 41:
                        _iteratorNormalCompletion4 = true;
                        _context7.next = 13;
                        break;

                    case 44:
                        _context7.next = 50;
                        break;

                    case 46:
                        _context7.prev = 46;
                        _context7.t1 = _context7['catch'](11);
                        _didIteratorError4 = true;
                        _iteratorError4 = _context7.t1;

                    case 50:
                        _context7.prev = 50;
                        _context7.prev = 51;

                        if (!_iteratorNormalCompletion4 && _iterator4.return) {
                            _iterator4.return();
                        }

                    case 53:
                        _context7.prev = 53;

                        if (!_didIteratorError4) {
                            _context7.next = 56;
                            break;
                        }

                        throw _iteratorError4;

                    case 56:
                        return _context7.finish(53);

                    case 57:
                        return _context7.finish(50);

                    case 58:
                        _context7.next = 86;
                        break;

                    case 60:
                        _iteratorNormalCompletion6 = true;
                        _didIteratorError6 = false;
                        _iteratorError6 = undefined;
                        _context7.prev = 63;
                        _iterator6 = (0, _getIterator3.default)(opts.files);

                    case 65:
                        if (_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done) {
                            _context7.next = 72;
                            break;
                        }

                        _file = _step6.value;
                        _context7.next = 69;
                        return muckFile({ name: '.', location: process.cwd() }, _file, opts);

                    case 69:
                        _iteratorNormalCompletion6 = true;
                        _context7.next = 65;
                        break;

                    case 72:
                        _context7.next = 78;
                        break;

                    case 74:
                        _context7.prev = 74;
                        _context7.t2 = _context7['catch'](63);
                        _didIteratorError6 = true;
                        _iteratorError6 = _context7.t2;

                    case 78:
                        _context7.prev = 78;
                        _context7.prev = 79;

                        if (!_iteratorNormalCompletion6 && _iterator6.return) {
                            _iterator6.return();
                        }

                    case 81:
                        _context7.prev = 81;

                        if (!_didIteratorError6) {
                            _context7.next = 84;
                            break;
                        }

                        throw _iteratorError6;

                    case 84:
                        return _context7.finish(81);

                    case 85:
                        return _context7.finish(78);

                    case 86:
                    case 'end':
                        return _context7.stop();
                }
            }
        }, _callee7, this, [[11, 46, 50, 58], [18, 29, 33, 41], [34,, 36, 40], [51,, 53, 57], [63, 74, 78, 86], [79,, 81, 85]]);
    }));

    return function muck(_x23) {
        return _ref10.apply(this, arguments);
    };
}();

exports.makeOptions = makeOptions;

var _set2 = require('lodash/set');

var _set3 = _interopRequireDefault(_set2);

var _unset = require('lodash/unset');

var _unset2 = _interopRequireDefault(_unset);

var _has = require('lodash/has');

var _has2 = _interopRequireDefault(_has);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _mrbuilderUtils = require('mrbuilder-utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var settings = exports.settings = {
    exit: process.exit,
    error: console.error,
    warn: console.warn,
    log: console.log,
    trace: console.trace
};

var write = function write(filename, json) {
    return new _promise2.default(function (resolve, reject) {
        return _fs2.default.writeFile(filename, (0, _stringify2.default)(json, null, 2), 'utf8', function (e, o) {
            return e ? reject(e) : resolve(o);
        });
    });
};

var read = function read(filename) {
    return new _promise2.default(function (resolve, reject) {
        return _fs2.default.readFile(filename, 'utf8', function (e, o) {
            return e ? reject(e) : resolve(JSON.parse(o));
        });
    });
};

function parse(value) {
    value = value.trim();
    if (value === 'true' || value === 'false') {
        return JSON.parse(value);
    }
    if (value === 'null') {
        return null;
    }
    if (value === '') {
        return value;
    }
    if (value.startsWith('{') && value.endsWith('}') || value.startsWith('[') && value.endsWith(']') || value.startsWith('"') && value.endsWith('"') || /^((?:NaN|-?(?:(?:\d+|\d*\.\d+)(?:[E|e][+|-]?\d+)?|Infinity)))$/.test(value)) {
        return JSON.parse(value);
    }
    return JSON.parse('"' + value + '"');
}

function __get(key) {
    return (0, _stringify2.default)((0, _get3.default)(this, key));
}

function _get(json, keys, filename) {
    var opts = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

    var str = keys.map(__get, json).join(',');
    if (str) {
        if (opts.skipIfExists) {
            return false;
        }
    } else {
        if (opts.onlyIfExists) {
            return false;
        }
    }
    settings.log(this.name, '=', str);
    return false;
}function makeOptions(name, args) {
    function help(msg) {
        if (msg) {
            settings.error(msg);
        }
        settings.warn(name + '   [-sdgihfe] <files>\n      -b\t--backup\t<extension>\tuse a different extension\n      -p\t--prompt\tkey=question\tprompt for value before changing\n      -c\t--confirm\t\tconfirm before dangerous operations\n      -m\t--move\t\tfrom=to\tMove property from=to\n      -s\t--set\t\tkey=value sets key to value\n      -d\t--delete\tkey\tdeletes values (comma)\n      -g\t--get\t\tvalue\tgets the value\n      -i\t--ignore\tpackages to ignore\n      -h\t--help\t\tthis helpful message\n      -f\t--file\t\tpackage.json default\n      -k\t--skip\t\tSkip the question if it has value\n      -n\t--no-lerna\tJust use the file don\'t iterate over lerna projects\n      -C\t--create-file\tCreate the file if it does not exist\n      -P\t--preview\tPreview files if there are changes, before writing.\n      -u\t--unless\tDo the action only if it has a value \n      -S\t--scope packages,\t Only apply to these packages (glob).\n      --no-extension\tuse in place\n    ');
        settings.exit(1);
    }

    var opts = {
        extension: '.bck',
        files: [],
        commands: [],
        options: {}
    };
    var commands = opts.commands;
    var options = opts.options;
    //need this to suck up files at the end.
    var i = 0;
    ARGS: for (var l = args.length; i < l; i++) {
        var _args$i$split = args[i].split('=', 2),
            _args$i$split2 = (0, _slicedToArray3.default)(_args$i$split, 2),
            arg = _args$i$split2[0],
            val = _args$i$split2[1];

        switch (arg) {
            //actions
            case '--prompt':
            case '-p':
                var message = val || args[++i];
                if (!message) {
                    throw new Error('message must be defined for "' + arg + '"');
                }
                commands.push([_prompt, message.split('=', 2)]);
                break;
            case '-s':
            case '--set':
                var _split = (val || args[++i]).split('=', 2),
                    _split2 = (0, _slicedToArray3.default)(_split, 2),
                    key = _split2[0],
                    value = _split2[1];

                commands.push([_set, [key, parse(value)]]);
                break;
            case '-d':
            case '--delete':
                var keys = (val || args[++i]).split(/,\s*/);
                commands.push([_delete, keys]);
                break;
            case '-g':
            case '--get':
                commands.push([_get, (val || args[++i]).split(/,\s*/)]);
                break;
            case '-m':
            case '--move':
                commands.push([_move, (val || args[++i]).split(/\s*=\s*/, 2)]);
                break;

            //options
            case '-k':
            case '--skip':
            case '--skip-if-exists':
                opts.skipIfExists = true;
                break;
            case '-u':
            case '--unless':
            case '--only-if-exists':
                opts.onlyIfExists = true;
                break;
            case '-c':
            case '--confirm':
                opts.confirm = true;
                break;
            case '-i':
            case '--ignore':
                options['ignore'] = args[++i];
                break;
            case '-f':
            case '--file':
                opts.files = opts.files.concat((val || args[++i]).split(/,\s*/));
                break;
            case '-C':
            case '--create-file':
                opts.createIfNotExists = true;
                break;
            case '-e':
            case '--extension':
            case '-b':
            case '--backup':
                opts['extension'] = (val || args[++i]).trim();
                if (!opts['extension']) {
                    return help('--backup requires an extension use --no-backup to rename in place');
                }
                break;
            case '-X':
            case '--no-extension':
            case '--no-backup':
                opts.noExtension = true;
                break;
            case '-n':
            case '--no-lerna':
                opts.noLerna = true;
                break;
            case '--preview':
            case '-P':
                opts.preview = true;
                break;
            case '--scope':
            case '-S':
                opts.scope = opts.files.concat((val || args[++i]).split(/,\s*/));
                break;
            case '-h':
            case '--help':
                return help();
            default:
                {
                    break ARGS;
                }

        }
    }
    if (commands.length === 0) {
        help('need a command ' + args);
    }
    opts.files = opts.files.concat(args.slice(i));
    if (opts.files.length === 0) {
        opts.files.push('package.json');
    }
    return opts;
}

if (require.main === module) {
    muck(makeOptions(process.argv[1], process.argv.slice(2))).then(function (res) {
        settings.exit(res);
    }, function (e) {
        settings.trace(e);
        process.exit(1);
    });
}
//# sourceMappingURL=muck.js.map